<template>
  <v-form v-model="valid">

    <v-row class="form glass">
      <v-col cols="12" md="4" style="justify-content: center;">
        <v-text-field :class="{ wrong: emailError }" v-model="email" :rules="emailRules" label="E-mail"
          required></v-text-field>
        <v-container fluid>
          <v-checkbox v-model="acceptTerms">
            <template v-slot:label>
              <div :class="{ wrong: !acceptTerms && toRegister }">
                Oświadczam, że zapoznałem się z treścią regulaminu i go akceptuję.
              </div>
            </template>
          </v-checkbox>

          <v-checkbox v-model="acceptPersonalData">
            <template v-slot:label>
              <div :class="{ wrong: !acceptPersonalData && toRegister }">
                Wyrażam zgodę na przetwarzanie moich danych osobowych przez *** sp. z o.o., w celu realizacji usług
                świadczonych na KuSobie.pl.
              </div>
            </template>
          </v-checkbox>

        </v-container>
        <v-btn @click="() => this.goToRegister(this.email)" block elevation="2" class="blob" fab icon plain raised text
          tile>Zarejestruj
          sie</v-btn>
      </v-col>
    </v-row>
    <v-snackbar v-model="snackbarError">
      {{ errorText }}
      <template v-slot:action="{ attrs }">
        <v-btn color="warning" text v-bind="attrs" @click="snackbarError = false">
          Zamknij
        </v-btn>
      </template>
    </v-snackbar>
  </v-form>
</template>
<script>
export default {
  data() {
    return {
      acceptTerms: false,
      acceptPersonalData: false,
      toRegister: false,
      snackbarError: false,
      valid: false,
      firstname: '',
      lastname: '',
      email: '',
      emailError: false,
      errorText: '',
      emailRules: [
        v => !!v || 'Podaj maila',
        v => /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'Mail musi być poprawny',
      ],
    }
  },

  methods: {

    async goToRegister(email) {
      this.toRegister = true;
      this.snackbarError = false;
      this.errorText = '';
      if (this.email === '') {
        this.emailError = true;
      }
      if (!(this.acceptPersonalData && this.acceptTerms)) {
        this.errorText = 'Wszystkie zgody powinny być zaznaczone.';
      }
      this.emailError = !/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(this.email)
      if (this.emailError) {
        this.errorText += ' Email powinien być poprawny.';
      }
      this.errorText = this.errorText.trim();

      if (this.errorText.length > 0) {
        this.snackbarError = true;
        return;
      }
      this.$axios.get(this.$config.serverUrl + '/user/get-by-email', { params: { email: this.email } })
        .then(async ({ data }) => {
          if (data.status === 'User exists') {
            this.errorText = 'Użytkownik o tym adresie jest już zarejestrowany';
            this.snackbarError = true;
          } else if (data.status === 'OK') {
            await this.$store.dispatch('setEmail', this.email)
            this.$router.push({ path: '/register' })

          }
        }).catch((e) => {
          console.error(e);
        });

    }
  }
}
</script>
<style scoped lang="scss">
form {
  .form {
    justify-content: center;
    width: 80%;
    background: rgba(255, 255, 255, 0.2) !important;

    .wrong {
      outline: 1px solid #fa8a7d !important;
      //filter: invert(100%);
    }

    .theme--light.v-btn.v-btn--icon {
      color: rgba(255, 255, 255, 1);
    }

    .blob {
      // background: black;
      // border-radius: 50%;
      margin: 10px;
      // height: 20px;
      // width: 20px;
      color: #fa8a7d;
      box-shadow: 0 0 0 0 rgba(0, 0, 0, 1);
      transform: scale(1);
      animation: pulse 2s;
      animation-iteration-count: 3;
    }

    @keyframes pulse {
      0% {
        transform: scale(0.95);
        box-shadow: 0 0 0 0 rgba(0, 0, 0, 0.7);
      }

      70% {
        transform: scale(1.5);
        box-shadow: 0 0 0 10px rgba(0, 0, 0, 0);
      }

      100% {
        transform: scale(0.95);
        box-shadow: 0 0 0 0 rgba(0, 0, 0, 0);
      }
    }
  }
}</style>